<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Trace.hh.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Trace.hh</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../Scopes/global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Trace.hh</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="comment">//</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="comment">// Copyright (C) 2004 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="comment">// All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="comment">// Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="comment">// see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="comment">//</span></span>
<a id="line7"></a><span class="lineno">  7</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line">#ifndef Synopsis_Trace_hh_</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line">#define Synopsis_Trace_hh_</span>
<a id="line10"></a><span class="lineno"> 10</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line">#include &lt;iostream&gt;</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line">#include &lt;string&gt;</span>
<a id="line13"></a><span class="lineno"> 13</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="keyword">namespace</span> <a href="../../Scopes/Synopsis.html" title="namespace Synopsis">Synopsis</a></span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line">{</span>
<a id="line16"></a><span class="lineno"> 16</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="keyword">class</span> <a href="../../Scopes/Synopsis/Trace.html" title="class Synopsis::Trace">Trace</a></span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line">{</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">  <span class="comment">// This category list is incomplete and needs to be filled in as</span></span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line"><span class="comment">  // more code is being written.</span></span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">  <span class="keyword">enum</span> <a href="../../Scopes/Synopsis/Trace.html#Category" title="enum Synopsis::Trace::Category">Category</a> { <a href="../../Scopes/Synopsis/Trace.html#NONE" title="enumerator Synopsis::Trace::NONE">NONE</a>=0x0,</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">		  <a href="../../Scopes/Synopsis/Trace.html#PTREE" title="enumerator Synopsis::Trace::PTREE">PTREE</a>=0x01,</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">		  <a href="../../Scopes/Synopsis/Trace.html#SYMBOLLOOKUP" title="enumerator Synopsis::Trace::SYMBOLLOOKUP">SYMBOLLOOKUP</a>=0x02,</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">		  <a href="../../Scopes/Synopsis/Trace.html#PARSING" title="enumerator Synopsis::Trace::PARSING">PARSING</a>=0x04,</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">		  <a href="../../Scopes/Synopsis/Trace.html#TRANSLATION" title="enumerator Synopsis::Trace::TRANSLATION">TRANSLATION</a>=0x08,</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">		  <a href="../../Scopes/Synopsis/Trace.html#ALL" title="enumerator Synopsis::Trace::ALL">ALL</a>=0xff};</span>
<a id="line28"></a><span class="lineno"> 28</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">  <span class="keyword">struct</span> <a href="../../Scopes/Synopsis/Trace/Entry.html" title="struct Synopsis::Trace::Entry">Entry</a></span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">  {</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">    <a href="../../Scopes/Synopsis/Trace/Entry.html#Entry_lbool_r" title="member function Synopsis::Trace::Entry::Entry(bool)">Entry</a>(<span class="keyword">bool</span> e);</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">    <a href="../../Scopes/Synopsis/Trace/Entry.html#Entry_lconst.Entry_A_r" title="member function Synopsis::Trace::Entry::Entry(const Entry&amp;)">Entry</a>(<a href="../../Scopes/Synopsis/Trace/Entry.html" title="struct Synopsis::Trace::Entry">Entry const</a> &amp;e) : enabled(e.enabled) { <a href="" title="parameter e">e</a>.<a href="../../Scopes/Synopsis/Trace/Entry.html#enabled" title="data member Synopsis::Trace::Entry::enabled">enabled</a> = false;}</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">    <a href="../../Scopes/Synopsis/Trace/Entry.html#_tEntry_l_r" title="member function Synopsis::Trace::Entry::~Entry()">~Entry</a>();</span>
<a id="line34"></a><span class="lineno"> 34</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">    template &lt;typename T&gt; <a href="../../Scopes/Synopsis/Trace/Entry.html" title="struct Synopsis::Trace::Entry">Entry const</a> &amp;<a href="../../Scopes/Synopsis/Trace/Entry.html#operator_L_L_lconst.T_A_rconst" title="member function template Synopsis::Trace::Entry::operator&lt;&lt;(const T&amp;)const">operator&lt;&lt;</a>(T const &amp;t) const;</span>
<a id="line36"></a><span class="lineno"> 36</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">    mutable <span class="keyword">bool</span> <a href="../../Scopes/Synopsis/Trace/Entry.html#enabled" title="data member Synopsis::Trace::Entry::enabled">enabled</a>;</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">  };</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">  friend struct Entry;</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">  <a href="" title="member function Synopsis::Trace::Trace(const std::string&amp;,unsigned int)">Trace</a>(<a href="" title="typedef std::string">std::string const</a> &amp;s, <span class="keyword">unsigned int</span> c)</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">    : my_scope(s), my_visibility(my_mask &amp; c)</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">  {</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">    <span class="keyword">if</span> (!<a href="../../Scopes/Synopsis/Trace.html#my_visibility" title="data member Synopsis::Trace::my_visibility">my_visibility</a>) <span class="keyword">return</span>;</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">    <a href="" title="namespace variable std::cout">std::cout</a> &lt;&lt; <a href="../../Scopes/Synopsis/Trace.html#indent_l_r" title="member function Synopsis::Trace::indent()">indent</a>() &lt;&lt; <span class="string">&quot;entering &quot;</span> &lt;&lt; <a href="../../Scopes/Synopsis/Trace.html#my_scope" title="data member Synopsis::Trace::my_scope">my_scope</a> &lt;&lt; std::endl;</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">    ++<a href="../../Scopes/Synopsis/Trace.html#my_level" title="data member Synopsis::Trace::my_level">my_level</a>;</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">  }</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">  template &lt;typename T&gt;</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">  <a href="" title="member function template Synopsis::Trace::Trace(const std::string&amp;,unsigned int,const T&amp;)">Trace</a>(<a href="" title="typedef std::string">std::string const</a> &amp;s, <span class="keyword">unsigned int</span> c, T const &amp;t)</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">    : my_scope(s), my_visibility(my_mask &amp; c)</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">  {</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">    <span class="keyword">if</span> (!my_visibility) <span class="keyword">return</span>;</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">    <a href="" title="namespace variable std::cout">std::cout</a> &lt;&lt; indent() &lt;&lt; <span class="string">&quot;entering &quot;</span> &lt;&lt; my_scope &lt;&lt; <span class="string">' '</span> &lt;&lt; <a href="" title="parameter t">t</a> &lt;&lt; std::endl;</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">    ++my_level;</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">  }</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">  <a href="../../Scopes/Synopsis/Trace.html#_tTrace_l_r" title="member function Synopsis::Trace::~Trace()">~Trace</a>()</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">  {</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">    <span class="keyword">if</span> (!<a href="../../Scopes/Synopsis/Trace.html#my_visibility" title="data member Synopsis::Trace::my_visibility">my_visibility</a>) <span class="keyword">return</span>;</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">    --<a href="../../Scopes/Synopsis/Trace.html#my_level" title="data member Synopsis::Trace::my_level">my_level</a>;</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">    <a href="" title="namespace variable std::cout">std::cout</a> &lt;&lt; <a href="../../Scopes/Synopsis/Trace.html#indent_l_r" title="member function Synopsis::Trace::indent()">indent</a>() &lt;&lt; <span class="string">&quot;leaving &quot;</span> &lt;&lt; <a href="../../Scopes/Synopsis/Trace.html#my_scope" title="data member Synopsis::Trace::my_scope">my_scope</a> &lt;&lt; std::endl;</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">  }</span>
<a id="line61"></a><span class="lineno"> 61</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">  template &lt;typename T&gt;</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">  <a href="../../Scopes/Synopsis/Trace/Entry.html" title="struct Synopsis::Trace::Entry">Entry</a> <a href="../../Scopes/Synopsis/Trace.html#operator_L_L_lconst.T_A_rconst" title="member function template Synopsis::Trace::operator&lt;&lt;(const T&amp;)const">operator&lt;&lt;</a>(T const &amp;t) const;</span>
<a id="line64"></a><span class="lineno"> 64</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">  static <span class="keyword">void</span> <a href="../../Scopes/Synopsis/Trace.html#enable_lunsigned.int_r" title="member function Synopsis::Trace::enable(unsigned int)">enable</a>(<span class="keyword">unsigned int</span> mask = ALL) { <a href="../../Scopes/Synopsis/Trace.html#my_mask" title="data member Synopsis::Trace::my_mask">my_mask</a> = <a href="" title="parameter mask">mask</a>;}</span>
<a id="line66"></a><span class="lineno"> 66</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">  static <a href="" title="typedef std::string">std::string</a> <a href="../../Scopes/Synopsis/Trace.html#indent_l_r" title="member function Synopsis::Trace::indent()">indent</a>() { <span class="keyword">return</span> std::string(<a href="../../Scopes/Synopsis/Trace.html#my_level" title="data member Synopsis::Trace::my_level">my_level</a>, <span class="string">' '</span>);}</span>
<a id="line69"></a><span class="lineno"> 69</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">  static <span class="keyword">unsigned int</span> <a href="../../Scopes/Synopsis/Trace.html#my_mask" title="data member Synopsis::Trace::my_mask">my_mask</a>;</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">  static <a href="" title="typedef size_t">size_t</a>       <a href="../../Scopes/Synopsis/Trace.html#my_level" title="data member Synopsis::Trace::my_level">my_level</a>;</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">  <a href="" title="typedef std::string">std::string</a>         <a href="../../Scopes/Synopsis/Trace.html#my_scope" title="data member Synopsis::Trace::my_scope">my_scope</a>;</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">  <span class="keyword">bool</span>                <a href="../../Scopes/Synopsis/Trace.html#my_visibility" title="data member Synopsis::Trace::my_visibility">my_visibility</a>;</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">};</span>
<a id="line75"></a><span class="lineno"> 75</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">inline <a href="../../Scopes/Synopsis/Trace/Entry.html#Entry_lbool_r" title="member function Synopsis::Trace::Entry::Entry(bool)">Trace::Entry::Entry</a>(<span class="keyword">bool</span> e) </span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">  : enabled(e)</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">{</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">  <span class="keyword">if</span> (<a href="../../Scopes/Synopsis/Trace/Entry.html#enabled" title="data member Synopsis::Trace::Entry::enabled">enabled</a>)</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">    <a href="" title="namespace variable std::cout">std::cout</a> &lt;&lt; <a href="../../Scopes/Synopsis/Trace.html#indent_l_r" title="member function Synopsis::Trace::indent()">Trace::indent</a>();</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">}</span>
<a id="line82"></a><span class="lineno"> 82</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">inline <a href="../../Scopes/Synopsis/Trace/Entry.html#_tEntry_l_r" title="member function Synopsis::Trace::Entry::~Entry()">Trace::Entry::~Entry</a>() </span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">{</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">  <span class="keyword">if</span> (<a href="../../Scopes/Synopsis/Trace/Entry.html#enabled" title="data member Synopsis::Trace::Entry::enabled">enabled</a>)</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">    <a href="" title="namespace variable std::cout">std::cout</a> &lt;&lt; std::endl;</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">}</span>
<a id="line88"></a><span class="lineno"> 88</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">template &lt;typename T&gt; </span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">inline Trace::Entry const &amp;Trace::Entry::operator&lt;&lt;(T const &amp;t) const</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">{</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">  if (enabled)</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">    std::cout &lt;&lt; t;</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">  return *this;</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">}</span>
<a id="line96"></a><span class="lineno"> 96</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">template &lt;typename T&gt;</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">inline Trace::Entry Trace::operator&lt;&lt;(T const &amp;t) const</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">{</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">  Entry entry(my_visibility);</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">  return entry &lt;&lt; t;</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">}</span>
<a id="line103"></a><span class="lineno">103</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">}</span>
<a id="line105"></a><span class="lineno">105</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">#endif</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:28:03 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
